/*==============================================================================
 * BUTTON FUNCTIONS                                                                
 *============================================================================*/
 
void ButtonAHold()
{
  
 //This will switch the Screen
   switch(Screen){
   case 0:
      Screen = 1;
      Screen1Init();
      break;
   case 1:
      Screen = 3;
      Screen3Init();    //JMP Directly to Screen 3 (Screen 2 not needed for Andi)
      break;
   case 2:
      Screen = 3;
      Screen3Init();
      break;
   case 3:
      Screen = 5;        //Jmp directly to Screen 5 (Screen 4 not needed for Andi)
      Screen5Init();
      break;
   case 4:
      Screen = 5;
      Screen5Init();
      break;
   case 5:
      Screen = 6;
      Screen6Init();
      break;
   case 6:
      Screen = 7;
      Screen7Init();
      break;      
  case 7:
      Screen = 1;      //JMP Over 8/9 to Screen 1 (Screen 8/9 not needed for Andi)
      Screen1Init();
      break;   
  case 8:
      Screen = 9;
      //Screen9Init();
      break;    
  case 9:
      Screen = 1;
      Screen1Init();
      break;    
   default:
      Screen = 0;
      break;
   }
   
  //Set the Timestamp for the Save:
  
  ScreenSave = millis() + ScreenSaveDelay;
   
}

//-------------------------------------------------------------------------------------------------------

void ButtonAPressed()
{
  
  //Serial.print(time*1);
  //Serial.print(";");
  //Serial.println("Button A Pressed");
  
  switch(Screen){
   case 0:
      break;
   case 1:
      ChangeSerOut();      //Switch from RAW to Cal to Nothing and vise versa.
      break;
   case 2:
       //Toggle A and B MCP
      if(val1==8)
      {
        Screen2Init();
      }
      else
      {
        Screen2InitB();
      }
      break; 
   case 3:
      ChangeSerOut();      //Switch from RAW to Cal to Nothing and vise versa.
      break;
   case 5:
       
      //The MaxLD will be reset!
      MaxLD = 0.0;
      MaxLDt = LDcalPoint;
       //Setpoint = Setpoint - 0.1;
       //Setpoint = round(Setpoint*10)/10;    //Makes the number straight
       //EEPROMWriteDouble(150,Setpoint*1000);    //writes the float as long, will do it.
       break;
   case 6:                 //Switches the 2 Row Screen
	  switch(val1){
	   case 1:
	     val1 = 2;
             Screen6Init();
	     break;
	   case 2:
	     val1 = 1;
             Screen6Init();
	     break;
	  }
      break;
   case 7:
      RefResh = RefResh + 5;
      if(RefResh>=32)
      {
        RefResh = 0;
      }
      break;
   default:
      break;
  }
 
}

//-------------------------------------------------------------------------------------------------------

void ButtonBHold()
{
 
  //Serial.print(time*1);
  //Serial.print(";");
  //Serial.println("Button B Hold"); 
   
  switch(Screen){
   case 0:
      break;
   case 1:
      //The Calibration from the LD will be done
      CalibrateLD();      
      break;
   case 5:
      ToggleBoost();    //Switch from % to PID and vise versa
      break;
   default:
   break;
  }
   
}

//-------------------------------------------------------------------------------------------------------

void ButtonBPressed()
{
  
  //Serial.print(time*1);
  //Serial.print(";");
  //Serial.println("Button B Pressed");
 
   switch(Screen){
   case 0:
      break;
   case 1:
      //The MaxLD will be reset!
      MaxLD = 0.0;
      MaxLDt = LDcalPoint;
      break;
   case 3:
      //Change LCD Brightness
      Brightness++;
      if(Brightness>=3)
      {
        Brightness = 0;
      }
      LCDBrightness(Brightness);
      //and save the new value:
      EEPROM.write(105,Brightness); 
      break;
   case 5:
   
      if(bHCduty==0)
      { 
        Setpoint = Setpoint + 0.1;
       EEPROMWriteDouble(150,Setpoint*1000);    //writes the float as long, will do it.
      }else
      {
        iHCdutyvalue = iHCdutyvalue + 10;
        EEPROM.write(110,iHCdutyvalue);  
      }
       
       break;
   case 7:
      val4++;      //Change the Scope Screen
      if(val4>=5)
      {
        val4 = 1;
      }
      //Reset the Constrains:
      val1 = 0;
      val2 = 5000;
      break;
   case 8:
      val1++;	//changes the MAX screen through all values
      if(val1>=4)
      {
       val1 = 1;
      }
      break;

   default:
   break;
  }
 
 
}

//-------------------------------------------------------------------------------------------------------

 void ButtonCheck()
 {
	 
	int ButtonState = 3;
        int reading = 0;

	/*
	3 = open
	1 = s1
	2 = s2
	*/

        //V2, the Buttons are direct connected to IO´s!
        reading = digitalRead(Button1);
        if(reading == 1)
        {
          ButtonState = ButtonState - 2;
          reading = 0;
        }
 
        reading = digitalRead(Button2);
        if(reading == 1)
        {
          ButtonState = ButtonState - 1;
        }

	//now a little inteligent stuff:

	switch(ButtonState) {
	  case 1:
	   if(ButtonTime == 0)
	   {
		 ButtonAPressed();
		 ButtonTime = millis();
	   }
	   else
	   {
		 if(millis()>=ButtonTime+ButtonHold)
		 {
		   ButtonAHold();
		   ButtonTime = millis();
		 }
	   }
	   break;
	   
	  case 2:
	   if(ButtonTime == 0)
	   {
		 ButtonBPressed();
		 ButtonTime = millis();
	   }
	   else
	   {
		 if(millis()>=ButtonTime+ButtonHold)
		 {
		   ButtonBHold();
		   ButtonTime = millis();
		 }
	   }
	   break;
	   
	  case 3:
	   ButtonTime = 0;
	   break;
	  }

	 //Thats it... easy.

 }


